﻿using Microsoft.AspNetCore.Authentication.JwtBearer;

namespace Infrastructure.Security;

public class JwtBearerOptionsPostConfigureOptions(
    DefaultTokenHandler tokenHandler,
    ITokenBuilder tokenBuilder)
    : IPostConfigureOptions<JwtBearerOptions>
{
    public void PostConfigure(string? name, JwtBearerOptions options)
    {
        options.TokenHandlers.Clear();
        options.TokenHandlers.Add(tokenHandler);
        options.Events.OnTokenValidated = context =>
        {
            return Task.Run(() => { tokenBuilder.SetUserContext(context); });
        };
    }
}